package quake.quake_android_native_methods.Wave;

import android.app.Activity;
import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PointF;
import android.util.AttributeSet;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

import quake.quake_android_native_methods.R;

public class WaveView extends View implements View.OnKeyListener {
    //画笔
    private Paint mPaint;
    private Paint cursorPaint;
    private String windowStatus = "nothingChange";
    private int smallWindowHeight;
    private int bigWindowHeight;


    private List<PointF> dataPoint = new ArrayList<>(); //点的集合
    private int windowWidth;
    private int windowHeight;
    private static float valueY = 0;
    private int maxValue = 100;//计算Y值的基数
    private int distance = 10; //每一个点走的距离
    private Random random = new Random();
    private String TAG = "WaveView";
    private boolean isBig;


    public boolean isBig() {
        return isBig;
    }

    public void setBig(boolean big) {
        isBig = big;
    }
    private boolean isPause = true;

    private boolean isStart = false;

    public boolean isStart() {
        Log.d(TAG, "isStart: 开始"+isStart);
        return isStart;
    }

    public void setStart(boolean start) {
        Log.d(TAG, "setStart: 开始"+start);
        isStart = start;
    }

    public WaveView(Context context) {
        this(context, null);
    }


    public WaveView(Context context, AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public WaveView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        TypedArray array = context.obtainStyledAttributes(attrs, R.styleable.WaveView);
        mPaint = new Paint();
        mPaint.setColor(array.getColor(R.styleable.WaveView_paintColor, Color.BLACK));
//        mPaint.setColor(array.getColor(R.styleable.WaveView_paintColor, Color.BLACK));
        mPaint.setStrokeWidth(5);
        mPaint.setStyle(Paint.Style.STROKE);

        cursorPaint = new Paint();
        cursorPaint.setColor(array.getColor(R.styleable.WaveView_paintColor, Color.BLACK));
        cursorPaint.setStrokeWidth(2);
        cursorPaint.setStyle(Paint.Style.FILL);
        if (windowWidth == 0) {
            initWindowWidth(context);
        }
    }
    public boolean isPause() {
        return isPause;
    }

    public void setPause(boolean pause) {
        isPause = pause;
    }

    public String getWindowStatus() {
        Log.d(TAG, "getWindowStatus: 窗口状态="+windowStatus);
        return windowStatus;
    }

    public void setWindowStatus(String windowStatus) {
        this.windowStatus = windowStatus;
    }

    public static float getValueY() {
        return valueY;
    }

    public static void setValueY(float valueY) {
        WaveView.valueY = valueY;
    }

    //    获取屏幕宽度
    private void initWindowWidth(Context context) {
        WindowManager manager = ((Activity) context).getWindowManager();
        DisplayMetrics outMetrics = new DisplayMetrics();
        manager.getDefaultDisplay().getMetrics(outMetrics);
        windowWidth = outMetrics.widthPixels;
    }

    //    波形图Y值计算方法
    private float calculateY(String upOrDown) {
        windowHeight = getHeight();
//        float caulate = (float) Math.abs(windowHeight - ((valueY -4157) / maxValue * windowHeight));
//        if (caulate > 100){
//            caulate = 100;
//        }
//        if (caulate < 0){
//            caulate = 0 ;
//        }
//        return  caulate;
        Log.d(TAG, "caculateY: 窗口高度:" + windowHeight);
        Log.d(TAG, "caculateY: getValueY=" + getValueY());
        float Y;
        if(upOrDown.equals("up")){
//            Y = (float) windowHeight / 2 + getValueY() / ((float) 100/ (windowHeight/2));
            if(getValueY()<=40){
                Y = (float) windowHeight / 2 + getValueY() / ((float) 1000 / windowHeight);
            }
            else if(getValueY()>40&&getValueY()<=50){
                Y = (float) windowHeight / 2 + getValueY() / ((float) 800 / windowHeight);
            }else if(getValueY()>50&&getValueY()<=60){
                Y = (float) windowHeight / 2 + getValueY() / ((float) 600 / windowHeight);
            }else if(getValueY()>60&&getValueY()<=70){
                Y = (float) windowHeight / 2 + getValueY() / ((float) 400 / windowHeight);
            }else if(getValueY()>70&&getValueY()<=80){
                Y = (float) windowHeight / 2 + getValueY() / ((float) 200 / windowHeight);
            }else{
                Y = (float) windowHeight / 2 + getValueY() / ((float) 100 / windowHeight);
            }
        }else {
//            Y = (float) windowHeight / 2 - getValueY() / ((float) 100 / (windowHeight/2));
            if(getValueY()<=40){
                Y = (float) windowHeight / 2 - getValueY() / ((float) 1000 / windowHeight);
            }
            else if(getValueY()>40&&getValueY()<=50){
                Y = (float) windowHeight / 2 - getValueY() / ((float) 800 / windowHeight);
            }else if(getValueY()>50&&getValueY()<=60){
                Y = (float) windowHeight / 2 - getValueY() / ((float) 600 / windowHeight);
            }else if(getValueY()>60&&getValueY()<=70){
                Y = (float) windowHeight / 2 - getValueY() / ((float) 400 / windowHeight);
            }else if(getValueY()>70&&getValueY()<=80){
                Y = (float) windowHeight / 2 - getValueY() / ((float) 200 / windowHeight);
            }else{
                Y = (float) windowHeight / 2 - getValueY() / ((float) 100 / windowHeight);
            }
        }
//        valueY =(float) windowHeight/2;
//        valueY =getValueY();
//        valueY =windowHeight/2+ random.nextInt(windowHeight/2-20);
        Log.d(TAG, "caculateY: valueY=" + valueY / (200 / windowHeight));
        return Y;
    }

    public int getSmallWindowHeight() {
        return smallWindowHeight;
    }

    public void setSmallWindowHeight(int smallWindowHeight) {
        this.smallWindowHeight = smallWindowHeight;
    }

    public int getBigWindowHeight() {
        return bigWindowHeight;
    }

    public void setBigWindowHeight(int bigWindowHeight) {
        this.bigWindowHeight = bigWindowHeight;
    }
    public void clearPoint(){
        if(dataPoint!=null)
        dataPoint.clear();
    }

    private void drawPath(Canvas canvas) {
        if (dataPoint.size() == 0) {    //如果点的数量为0
//            PointF point1 = new PointF(windowWidth-2,caculateY());
//            PointF point1 = new PointF(2, caculateY());
            PointF point1 = new PointF(windowWidth-distance-2, calculateY("down"));
            dataPoint.add(0, point1);
//            PointF point2 = new PointF(2, (float) windowHeight / 2 - getValueY() / ((float) 400 / windowHeight));
//            PointF point2 = new PointF(windowWidth-distance-2, (float) windowHeight / 2 - getValueY() / ((float) 400 / windowHeight));
            PointF point2 = new PointF(windowWidth-distance-2, calculateY("up"));
//            PointF point2 = new PointF(windowWidth - distance - 2,caculateY());
            dataPoint.add(0, point2);
            Log.e(TAG, "drawPath: 点的数量为0 dataPoint.get(0).x：" + dataPoint.get(0).x);
            Log.e(TAG, "drawPath: 点的数量为0 dataPoint.get(1).x：" + dataPoint.get(1).x);
            return;
        } else {
//            if (dataPoint.get(0).x <= windowWidth - distance + 2 && dataPoint.get(1).x <= windowWidth - 2){
            if (dataPoint.get(0).x >= -distance + 2 && dataPoint.get(1).x >= -2) {
                Log.e(TAG, "drawPath: 进来了吗");
//                PointF point = new PointF(dataPoint.get(0).x - distance + 2,caculateY());
                Log.d(TAG, "drawPath: 暂停了吗"+isPause);
                //如果没有暂停
                if(!isPause()){
                    PointF point1 = new PointF(dataPoint.get(0).x, calculateY("down"));
                    dataPoint.add(0, point1);
//                    PointF point2 = new PointF(dataPoint.get(0).x, (float) windowHeight / 2 - getValueY() / ((float) 400 / windowHeight));
                    PointF point2 = new PointF(dataPoint.get(0).x, calculateY("up"));
                    dataPoint.add(0, point2);

                    Log.d(TAG, "drawPath: x坐标" + dataPoint.get(0).x);
                    Iterator<PointF> iterator = dataPoint.iterator();
                    //平移
                    while (iterator.hasNext()) {
                        PointF everyPoint = iterator.next();
                        everyPoint.offset(-10, 0);
//                    Log.e(TAG, "drawPath: dataPoint.get(1).x："+everyPoint.x );

//                    if (everyPoint.x < distance) {
//                    if (everyPoint.x < distance+2) {
//                        iterator.remove();
//                    }
                    }
                    dataPoint.get(0).offset(10, 0);
                    dataPoint.get(1).offset(10, 0);
                    Log.e(TAG, "drawPath: dataPoint.get(0).x：" + dataPoint.get(0).x);
                    Log.e(TAG, "drawPath: dataPoint.get(1).x：" + dataPoint.get(1).x);
                    Log.e(TAG, "drawPath: dataPoint.get(2).x：" + dataPoint.get(2).x);
                }
            }
        }

        //移除旧的点
        if (dataPoint.size() > 202) {
            for (int i = 202; i < dataPoint.size(); i++) {
                dataPoint.remove(i);
            }
        }


        //大小窗口切换
        if (getWindowStatus().equals("small2Big")) {
            for (int i = 2; i < dataPoint.size(); i++) {
                bigWindowHeight = getHeight();
                Log.d(TAG, "drawPath: 窗口高度小="+smallWindowHeight+
                        ",窗口高度大="+bigWindowHeight
                        +",小比大比例="+((float)smallWindowHeight/(float)bigWindowHeight));
                dataPoint.get(i).y = dataPoint.get(i).y / ((float)smallWindowHeight / (float)bigWindowHeight);
//                        dataPoint.get(0).y = dataPoint.get(0).y / ((float)smallWindowHeight / (float)bigWindowHeight);
//                        dataPoint.get(1).y = dataPoint.get(1).y / ((float)smallWindowHeight / (float)bigWindowHeight);
//                dataPoint.get(i).y = dataPoint.get(i).y / ((float)231 / (float)566);
//                        dataPoint.get(i).y = bigWindowHeight/2;

                Log.d(TAG, "drawPath: 索引("+i+")的分贝值(小变大)="+dataPoint.get(i).y);
            }
            setWindowStatus("nothingChange");
        } else if (getWindowStatus().equals("big2Small")) {
            smallWindowHeight = getHeight();
            for (int i = 2; i < dataPoint.size(); i++) {
                Log.d(TAG, "drawPath: 索引0的分贝值="+dataPoint.get(0).y);
                        dataPoint.get(i).y = dataPoint.get(i).y / ((float)bigWindowHeight / (float)smallWindowHeight);
//                dataPoint.get(i).y = dataPoint.get(i).y / ((float)566 / (float)231);

                Log.d(TAG, "drawPath: 索引("+i+")的分贝值(大变小)="+dataPoint.get(i).y);
            }
            setWindowStatus("nothingChange");
        }

        //绘制
        PointF point_pre = null;
        Log.d(TAG, "drawPath: 个数=" + dataPoint.size());
        for (int i = dataPoint.size() - 1; i > 0; i--) {
            if (point_pre == null) {
                point_pre = dataPoint.get(i);
                continue;//第一个点
            } else {
                if (i % 2 == 0) {
                    Log.d(TAG, "drawPath: 画了吗");
                    Log.d(TAG, "drawPath: 遍历"+i+"(" + dataPoint.get(i).x + "," + dataPoint.get(i).y + ")");
                    Log.d(TAG, "drawPath: 个数="+dataPoint.size());
                    canvas.drawLine(dataPoint.get(i).x, dataPoint.get(i).y, point_pre.x, point_pre.y, mPaint);
//                    canvas.drawLine(dataPoint.get(i).x, dataPoint.get(i).y,dataPoint.get(i).x, dataPoint.get(i).y, mPaint);
//                    canvas.drawLine(dataPoint.get(i).x, 0, point_pre.x, point_pre.y, mPaint);
//                    canvas.drawLine(dataPoint.get(dataPoint.size()-1).x,0,dataPoint.get(dataPoint.size()-1).x,windowHeight,cursorPaint);
//                    canvas.drawLine(dataPoint.get(103).x,0,dataPoint.get(103).x,windowHeight,cursorPaint);
//                    canvas.drawLine(102*10+2,0,102*10+2,windowHeight,cursorPaint);
                    if(isBig())
                    canvas.drawLine(windowWidth-distance-2,0,windowWidth-distance-2,windowHeight,cursorPaint);

                }
                point_pre = dataPoint.get(i);
            }
        }
          /*  for (PointF everyPoint : dataPoint) {
            if (point_pre == null) {
                point_pre = everyPoint;
                continue;//第一个点
            } else {
                canvas.drawLine(everyPoint.x, everyPoint.y, point_pre.x, point_pre.y,mPaint);
                point_pre = everyPoint;
            }
//            canvas.drawCircle(everyPoint.x, everyPoint.y, 0, mPaint);
        }*/
    }

   /* private void drawPath(Canvas canvas){
        if (dataPoint.size() == 0) {    //如果点的数量为0
//            PointF point1 = new PointF(windowWidth-2,caculateY());
            PointF point1 = new PointF(2,caculateY());
            dataPoint.add(0, point1);
            PointF point2 = new PointF( 2-distance,caculateY());



//            PointF point2 = new PointF(windowWidth - distance - 2,caculateY());
            dataPoint.add(0, point2);
            Log.e(TAG, "drawPath: 点的数量为0 dataPoint.get(0).x："+dataPoint.get(0).x );
            Log.e(TAG, "drawPath: 点的数量为0 dataPoint.get(1).x："+dataPoint.get(1).x );
            return;
        } else {

//            if (dataPoint.get(0).x <= windowWidth - distance + 2 && dataPoint.get(1).x <= windowWidth - 2){
            Log.e(TAG, "drawPath: dataPoint.get(0).x："+dataPoint.get(0).x );
            Log.e(TAG, "drawPath: dataPoint.get(1).x："+dataPoint.get(1).x );
            if (dataPoint.get(0).x >=  -distance+2 && dataPoint.get(1).x >=-2){
                Log.e(TAG, "drawPath: 进来了吗" );
//                PointF point = new PointF(dataPoint.get(0).x - distance + 2,caculateY());
                PointF point = new PointF(dataPoint.get(0).x,caculateY());
                dataPoint.add(0,point);
                Log.d(TAG, "drawPath: x坐标"+dataPoint.get(0).x);
                Iterator<PointF> iterator = dataPoint.iterator();
                Log.d(TAG, "drawPath: 点的个数"+dataPoint.size()+"个");
                while (iterator.hasNext()) {
                    PointF everyPoint = iterator.next();
                    everyPoint.offset(5, 0);
                    Log.d(TAG, "drawPath: 遍历("+everyPoint.x+","+everyPoint.y+")");
//                    if (everyPoint.x < distance) {
//                    if (everyPoint.x < distance+2) {
//                        iterator.remove();
//                    }
                }
                dataPoint.get(0).offset(-5,0);
            }
        }

        if (dataPoint.size() >200) {
            for (int i = 200; i < dataPoint.size(); i++) {
                dataPoint.remove(i);
            }
        }
        PointF point_pre = null;
        Log.d(TAG, "drawPath: 个数="+dataPoint.size());
        for (int i = dataPoint.size()-1;i>0;i--){
            if (point_pre == null) {
                point_pre = dataPoint.get(i);
                continue;//第一个点
            } else {
                Log.d(TAG, "drawPath: 画了吗");
                canvas.drawLine(dataPoint.get(i).x, dataPoint.get(i).y, point_pre.x, point_pre.y,mPaint);
                point_pre = dataPoint.get(i);
            }
        }*/
      /*  for (PointF everyPoint : dataPoint) {
            if (point_pre == null) {
                point_pre = everyPoint;
                continue;//第一个点
            } else {
                canvas.drawLine(everyPoint.x, everyPoint.y, point_pre.x, point_pre.y,mPaint);
                point_pre = everyPoint;
            }
//            canvas.drawCircle(everyPoint.x, everyPoint.y, 0, mPaint);
        }*/
//    }


    //    绘制波形图

//    private void drawPath(Canvas canvas){
//        if (dataPoint.size() == 0) {    //如果点的数量为0
////            PointF point1 = new PointF(windowWidth-2,caculateY());
//            PointF point1 = new PointF(distance+2,caculateY());
//            dataPoint.add(0, point1);
//            PointF point2 = new PointF( 2,caculateY());
////            PointF point2 = new PointF(windowWidth - distance - 2,caculateY());
//            dataPoint.add(0, point2);
//            Log.e(TAG, "drawPath: dataPoint.get(0).x："+dataPoint.get(0).x );
//            Log.e(TAG, "drawPath: dataPoint.get(1).x："+dataPoint.get(1).x );
//            return;
//        } else {
//
////            if (dataPoint.get(0).x <= windowWidth - distance + 2 && dataPoint.get(1).x <= windowWidth - 2){
//            Log.e(TAG, "drawPath: dataPoint.get(0).x："+dataPoint.get(0).x );
//            Log.e(TAG, "drawPath: dataPoint.get(1).x："+dataPoint.get(1).x );
//            if (dataPoint.get(0).x >=  0 && dataPoint.get(1).x >= distance){
//                Log.e(TAG, "drawPath: 进来了吗" );
////                PointF point = new PointF(dataPoint.get(0).x - distance + 2,caculateY());
//                PointF point = new PointF(dataPoint.get(0).x + distance-2 ,caculateY());
//                dataPoint.add(0,point);
//                Iterator<PointF> iterator = dataPoint.iterator();
//                while (iterator.hasNext()) {
//                    PointF everyPoint = iterator.next();
//                    everyPoint.offset(1, 0);
////                    if (everyPoint.x < distance) {
//                    if (everyPoint.x < distance) {
//                        iterator.remove();
//                    }
//                }
//            }
//        }
//        if (dataPoint.size() >200) {
//            for (int i = 200; i < dataPoint.size(); i++) {
//                dataPoint.remove(i);
//            }
//        }
//        PointF point_pre = null;
//        Log.d(TAG, "drawPath: 个数="+dataPoint.size());
//        for (int i = dataPoint.size()-1;i>0;i--){
//            if (point_pre == null) {
//                point_pre = dataPoint.get(i);
//                continue;//第一个点
//            } else {
//                Log.d(TAG, "drawPath: 画了吗");
//                canvas.drawLine(dataPoint.get(i).x, dataPoint.get(i).y, point_pre.x, point_pre.y,mPaint);
//                point_pre = dataPoint.get(i);
//            }
//        }
//      /*  for (PointF everyPoint : dataPoint) {
//            if (point_pre == null) {
//                point_pre = everyPoint;
//                continue;//第一个点
//            } else {
//                canvas.drawLine(everyPoint.x, everyPoint.y, point_pre.x, point_pre.y,mPaint);
//                point_pre = everyPoint;
//            }
////            canvas.drawCircle(everyPoint.x, everyPoint.y, 0, mPaint);
//        }*/
//    }

    @Override
    protected void onDraw(Canvas canvas) {
        Log.d(TAG, "onDraw: 是否开始="+isStart());
        if(isStart()){
            drawPath(canvas);

        }
        postInvalidateDelayed(100);
    }


    @Override
    public boolean onKey(View v, int keyCode, KeyEvent event) {
        return false;
    }
}
