package quake.quake_android_native_methods.ui.filePage;


import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.RelativeLayout;

import androidx.annotation.RequiresApi;

import com.billy.android.swipe.SmartSwipe;
import com.billy.android.swipe.SmartSwipeWrapper;
import com.billy.android.swipe.SwipeConsumer;
import com.billy.android.swipe.consumer.ActivitySlidingBackConsumer;
import com.billy.android.swipe.listener.SwipeListener;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.callback.FileCallback;
import com.tencent.smtt.sdk.QbSdk;
import com.tencent.smtt.sdk.TbsReaderView;

import org.json.JSONObject;


import java.io.File;

import okhttp3.Call;
import okhttp3.Response;
import quake.quake_android_native_methods.R;
import quake.quake_android_native_methods.baseMvp.annotation.InjectPresenter;
import quake.quake_android_native_methods.databinding.FilePageBinding;
import quake.quake_android_native_methods.ui.base.BaseActivity;
import quake.quake_android_native_methods.ui.base.SlidingBackActivity;
import quake.quake_android_native_methods.ui.filePage.contract.IFilePageContract;
import quake.quake_android_native_methods.ui.filePage.presenter.FilePagePresenter;
import quake.quake_android_native_methods.utils.BitmapUtils;
import quake.quake_android_native_methods.utils.Constant;
import quake.quake_android_native_methods.utils.FileUtils;

public class FilePage extends BaseActivity<FilePagePresenter> implements TbsReaderView.ReaderCallback,
        IFilePageContract.View {
    private static final String TAG = "FilePage";
    //    private String url = "https://quake-hr-1253674864.cos.ap-guangzhou.myqcloud.com/dailyFiles/13/1103/2021/09/15/Pdf文件.pdf";
//    private String url = "http://www.baidu.com";
//    private String url = "https://quake-hr-1253674864.cos.ap-guangzhou.myqcloud.com/dailyFiles/13/1103/2021/09/15/新建 XLS 工作表.xls";
//    private String url = "https://quake-hr-1253674864.cos.ap-guangzhou.myqcloud.com/dailyFiles/13/1103/2021/09/15/新建文本文档.txt";
//    private String url = "https://quake-hr-1253674864.cos.ap-guangzhou.myqcloud.com/dailyFiles/13/1001/2021/08/05/test123.ppt";
    private String download = Environment.getExternalStorageDirectory() + "/download/test/document/";
    private String SNAPSHOT = Environment.getExternalStorageDirectory() + "/Quake/fileSnapshot/test/document/";
    private TbsReaderView mTbsReaderView;
    RelativeLayout mRelativeLayout;
    private JSONObject mFileInfo;
    private FileItem fileItem;
    private String url;
    private float w = 872;
    private float h = 213;
    private boolean hasTouched = false;
    @InjectPresenter
    FilePagePresenter presenter;

    private FilePageBinding binding;
    private String snapShotUrl = "";
    private ActivitySlidingBackConsumer consumer;

    @RequiresApi(api = Build.VERSION_CODES.N)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        presenter.getIntent(this);

        activitySlidingBack();
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);//去除时间与状态栏
    }


    //获取文件url
    private void getUrl() {
        fileItem = new FileItem(mFileInfo);
        url = fileItem.getUrl();
        Log.d(TAG, "getUrl: url = " + url);
    }

    //初始化文件
    private void initDoc() {
        int i = url.lastIndexOf("/");
        String docName = url.substring(i, url.length());
        Log.d("print", "---substring---" + docName);

        //判断是否在本地/[下载/直接打开]
        File docFile = new File(download, docName);
        if (docFile.exists()) {
            //存在本地;
            Log.d("print", "本地存在");
//            fileObserver = new MyFileObserver(FilePage.this,download);
//            fileObserver.startWatching();
            displayFile(docFile.toString(), docName);
        } else {
//本地不存在,则下载;使用的OkGo2.x;
            OkGo.get(url)//
                    .tag(this)//
                    .execute(new FileCallback(download, docName) {  //文件下载时，可以指定下载的文件目录和文件名
                        @Override
                        public void onSuccess(File file, Call call, Response response) {
                            // file 即为文件数据，文件保存在指定目录
                            Log.d("print", "下载文件成功");
//                            fileObserver = new MyFileObserver(FilePage.this,download);
//                            fileObserver.startWatching();
                            displayFile(download + file.getName(), file.getName());
                            Log.d("print", "" + file.getName());
                        }

                        @Override
                        public void downloadProgress(long currentSize, long totalSize, float progress, long networkSpeed) {
                            //这里回调下载进度(该回调在主线程,可以直接更新ui)
                            Log.d("print", "总大小---" + totalSize + "---文件下载进度---" + progress);
                        }
                    });
        }
    }

    private String tbsReaderTemp = Environment.getExternalStorageDirectory() + "/TbsReaderTemp";

    private void displayFile(String filePath, String fileName) {
        //增加下面一句解决没有TbsReaderTemp文件夹存在导致加载文件失败
        String bsReaderTemp = tbsReaderTemp;
        File bsReaderTempFile = new File(bsReaderTemp);
        if (!bsReaderTempFile.exists()) {
            Log.d("print", "准备创建/TbsReaderTemp！！");
            boolean mkdir = bsReaderTempFile.mkdir();
            if (!mkdir) {
                Log.d("print", "创建/TbsReaderTemp失败！！！！！");
            }
        }
        Bundle bundle = new Bundle();
        //指定文件路径
        bundle.putString("filePath", filePath);
        //指定腾讯文件缓存路径
        bundle.putString("tempPath", tbsReaderTemp);
        //预加载，判断格式是否正确，其中的getFileType方法是获取文件后缀
        boolean result = mTbsReaderView.preOpen(FileUtils.getFileType(fileName), false);
        Log.d("print", "查看文档---" + result);
        if (result) {
            mTbsReaderView.openFile(bundle);
        } else {
            Log.e(TAG, "Type is not support");
            QbSdk.clearAllWebViewCache(this, true);
        }
    }

    @Override
    public void onCallBackAction(Integer integer, Object o, Object o1) {
        Log.d(TAG, "onCallBackAction: hasTouched=" + hasTouched);
        Log.d(TAG, "onCallBackAction: mRelative=" + mRelativeLayout.getWidth());
        Log.d(TAG, "onCallBackAction: integer=" + integer + ",o=" + o + ",o1=" + o1);
        if ((integer == 12) && !hasTouched) {
            new Handler().postDelayed(new Runnable() {
                @Override
                public void run() {
                    hasTouched = true;
                    Bitmap bitmap = capture(FilePage.this);
//            Bitmap bitmap = fileObserver.getBitmap();
                    Log.d(TAG, "onCallBackAction: 图片=" + bitmap);
                    if (bitmap != null) {
                        bitmap = BitmapUtils.cropBitmap(bitmap, w, h, false);
                        File file = new File(SNAPSHOT);

                        if (!file.exists()) {
                            boolean mk = file.mkdirs();
                            if (mk) {
                                if (fileItem != null) {
                                    snapShotUrl = SNAPSHOT + fileItem.getUuid() + ".jpg";
                                } else {
                                    String fileName = FileUtils.getFileName(url);
                                    snapShotUrl = SNAPSHOT + fileName + ".jpg";
                                }
                                BitmapUtils.saveBitmap(snapShotUrl, bitmap);
                                Log.d(TAG, "onCallBackAction: bitmap=" + bitmap);
                            }
                        } else {
                            if (fileItem != null) {
                                snapShotUrl = SNAPSHOT + fileItem.getUuid() + ".jpg";
                            } else {
                                String fileName = FileUtils.getFileName(url);
                                snapShotUrl = SNAPSHOT + fileName + ".jpg";
                            }
                            BitmapUtils.saveBitmap(snapShotUrl, bitmap);
                            Log.d(TAG, "onCallBackAction: bitmap=" + bitmap);
                        }
                    }
                }
            }, 50);
        }
    }

    //截屏作为封面
    public static Bitmap capture(Activity activity) {
        activity.getWindow().getDecorView().setDrawingCacheEnabled(true);
        return activity.getWindow().getDecorView().getDrawingCache();
    }

    private void setIntent() {
        Intent intent = new Intent();
        intent.putExtra("snapShotUrl", snapShotUrl);
        Log.d(TAG, "onBackPressed: snapShotUrl = " + snapShotUrl);
        setResult(Constant.REQUEST_BROWSE_FILE, intent);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mTbsReaderView.onStop();
//        setIntent();

//        fileObserver.stopWatching();
    }

    @Override
    public void onBackPressed() {
//        super.onBackPressed();
        setIntent();
        this.finish();
    }

    @Override
    public void showErrorMessage(String error) {
        Log.d(TAG, "showErrorMessage: 错误日志：" + error);
    }

    @Override
    public void createFunctions() {
    }

    @Override
    protected FilePagePresenter createPresenter() {
        return new FilePagePresenter();
    }

    @Override
    public void initViews() {
        binding = FilePageBinding.inflate(getLayoutInflater());
        View rootView = binding.getRoot();
        setContentView(rootView);
        mTbsReaderView = new TbsReaderView(this, this);
        mRelativeLayout = findViewById(R.id.tbsView);
        mRelativeLayout.addView(mTbsReaderView, new RelativeLayout.LayoutParams(-1, -1));
    }

    @Override
    public void showFile(JSONObject fileInfo, float width, float height) {
        mFileInfo = fileInfo;
        Log.d(TAG, "showContent: 文件信息：" + mFileInfo);
        w = width;
        h = height;
        Log.d(TAG, "initView: 宽=" + w + ",高=" + h);
        Log.d(TAG, "initView: mFileInfo=" + mFileInfo);

        getUrl();

        initViews();
        initDoc();
    }
    private void activitySlidingBack2() {
        SmartSwipe.wrap(this)
                .addConsumer(new ActivitySlidingBackConsumer(this))
                .setRelativeMoveFactor(0.5f)
                .enableLeft();
    }
    //侧滑返回activity
    private void activitySlidingBack() {
        consumer = new ActivitySlidingBackConsumer(this);
        consumer.setRelativeMoveFactor(0.9f).addListener(new SwipeListener() {
            @Override
            public void onConsumerAttachedToWrapper(SmartSwipeWrapper wrapper, SwipeConsumer consumer) {

            }

            @Override
            public void onConsumerDetachedFromWrapper(SmartSwipeWrapper wrapper, SwipeConsumer consumer) {

            }

            @Override
            public void onSwipeStateChanged(SmartSwipeWrapper wrapper, SwipeConsumer consumer, int state, int direction, float progress) {


            }

            @Override
            public void onSwipeStart(SmartSwipeWrapper wrapper, SwipeConsumer consumer, int direction) {

            }

            @Override
            public void onSwipeProcess(SmartSwipeWrapper wrapper, SwipeConsumer consumer, int direction, boolean settling, float progress) {

            }

            @Override
            public void onSwipeRelease(SmartSwipeWrapper wrapper, SwipeConsumer consumer, int direction, float progress, float xVelocity, float yVelocity) {
                Log.d(TAG, "onSwipeRelease: 滑动返回");
                setIntent();
                finish();
            }

            @Override
            public void onSwipeOpened(SmartSwipeWrapper wrapper, SwipeConsumer consumer, int direction) {

            }

            @Override
            public void onSwipeClosed(SmartSwipeWrapper wrapper, SwipeConsumer consumer, int direction) {


            }
        });
        SmartSwipe.wrap(this)
                .addConsumer(consumer)
                .enableLeft();
    }
}