/**
 * Copyright (C), 2021-2021, 夸克科技有限公司
 * FileName: ContentPageModel
 * Author: Administrator
 * Date: 2021/10/20 12:03
 * Description:
 * History:
 * <author> <time> <version> <desc>
 * 作者姓名 修改时间 版本号 描述
 */
package quake.quake_android_native_methods.ui.filePage.model;

import android.app.Activity;
import android.content.Intent;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import quake.quake_android_native_methods.utils.JSONUtils.JsonUtils;


/**
 * @ClassName: ContentPageModel
 * @Description: java类作用描述
 * @Author: Administrator
 * @Date: 2021/10/20 12:03
 */
public class FilePageModel implements IFilePageModel {
    private static final String TAG = "FilePageModel";
    private OnLoadFileInfoListener mListener;


    private void getFileIntent(Activity activity) {
        Log.d(TAG, "getFileIntent: 进来了吗");
        Intent intent = activity.getIntent();
        Log.d(TAG, "getFileIntent: fileInfo="+intent.getStringExtra("fileInfo"));
        Log.d(TAG, "getFileIntent: url="+intent.getStringExtra("url"));
        JSONObject fileInfo = new JSONObject();
        float w;
        float h;
        if (intent.getExtras() != null) {
            if (intent.getStringExtra("fileInfo") != null) {
                try {
                    fileInfo = new JSONObject(intent.getStringExtra("fileInfo"));
                    Log.d(TAG, "getFileIntent: fileInfo=" + fileInfo.getString("url"));
                    w = intent.getFloatExtra("width", 872);
                    h = intent.getFloatExtra("height", 213);
                    mListener.onComplete(fileInfo, w, h);
                } catch (JSONException e) {
                    mListener.onError(e.getMessage());
                    e.printStackTrace();
                }
            }else if(intent.getStringExtra("url") != null){
                    fileInfo = JsonUtils.inputValue2JSONObject(fileInfo,"url",intent.getStringExtra("url"));
                    w = intent.getFloatExtra("width", 872);
                    h = intent.getFloatExtra("height", 213);
                    mListener.onComplete(fileInfo, w, h);
            }
        }
    }

    @Override
    public void getFileInfo(Activity activity, OnLoadFileInfoListener listener) {
        mListener = listener;
        getFileIntent(activity);
    }
}
