import 'dart:async';

import 'package:flutter/services.dart';

class QuakeAndroidNativeMethods {
  static const MethodChannel _channel =
      MethodChannel('quake_android_native_methods');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String?> goBack(String message) async {
    final String? res = await _channel
        .invokeMethod('goBack', <String, dynamic>{"message": message});
    return res;
  }

  /// 从相册选择图片
  static Future<String?> chooseImgFromGallery() async {
    final String? res = await _channel.invokeMethod('chooseImgFromGallery');
    return res;
  }

  ///  拍照
  static Future<String?> photograph() async {
    final String? res = await _channel.invokeMethod('photograph');

    return res;
  }

  /// 从视频选择器选择视频
  static Future<String?> chooseVideoFromSelector() async {
    final String? res = await _channel.invokeMethod('chooseVideoFromSelector');
    return res;
  }

  /// 录像
  static Future<String?> videoRecording() async {
    final String? res = await _channel.invokeMethod('videoRecording');
    return res;
  }

  /// 从文件选择器选择文件
  static Future<String?> chooseFileFromSelector() async {
    final String? res = await _channel.invokeMethod('chooseFileFromSelector');
    return res;
  }

  /// 查看文件
  static Future<String?> browseFile(String url) async {
    final String? res = await _channel
        .invokeMethod('browseFile', <String, dynamic>{'url': url});
    return res;
  }

  /// 录音
  static Future<String?> soundRecording() async {
    final String? res = await _channel.invokeMethod('soundRecording');
    return res;
  }

  ///发送定位
  static Future<String?> sendLocation() async {
    final String? res = await _channel.invokeMethod('sendLocation');
    return res;
  }
  ///扫描二维码
  static Future<String?> scanQRCode() async {
    final String? res = await _channel.invokeMethod('scanQRCode');
    return res;
  }
}
