import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:quake_android_native_methods/quake_android_native_methods.dart';

void main() {
  const MethodChannel channel = MethodChannel('quake_android_native_methods');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await QuakeAndroidNativeMethods.platformVersion, '42');
  });
}
